using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Sternenhimmel
{
	public class Punkt
	{
		public Point Position;

		public Punkt(int x, int y)
		{
			Position = new Point(x, y);
		}
	}

	public class frmMain : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;

		private Random myRandom = new Random();
		private const int iAnzahlPunkte = 50;
		private const int myScale = 1;
		private const double bogenmass = 0.25;
		private const int leuchtReichweite = 150;
		private const int leuchtKraft = 100;
		private ArrayList alPunkte = new ArrayList();

		public frmMain()
		{
			InitializeComponent();

			for(int i = 0; i < iAnzahlPunkte; i++)
			{
				alPunkte.Add(new Punkt(myRandom.Next(Size.Width / myScale), myRandom.Next(Size.Height / myScale)));
			}
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			DateTime dt = DateTime.Now;
			Graphics g = e.Graphics;
			SolidBrush brush = new SolidBrush(Color.Black);
			int gesamtHelligkeitInt, x, y, tmpX , tmpY;
			double Entfernung, Helligkeit, gesamtHelligkeit;

			for(x = 0; x < Size.Width / myScale; x++)
			{
				for(y = 0; y < Size.Height / myScale; y++)
				{
					gesamtHelligkeit = 0;

					foreach(Punkt p in alPunkte)
					{
						tmpX = p.Position.X - x; if(tmpX > leuchtReichweite) continue;
						tmpY = p.Position.Y - y; if(tmpY > leuchtReichweite) continue;

						Entfernung = Math.Sqrt((tmpX * tmpX) + (tmpY * tmpY));

						Helligkeit = leuchtKraft - Math.Pow(Entfernung, bogenmass) * (leuchtKraft / (Math.Pow(leuchtReichweite, bogenmass)));
						if(Helligkeit < 0) Helligkeit = 0;

						gesamtHelligkeit += Helligkeit;
					}

					if(gesamtHelligkeit > 255) gesamtHelligkeit = 255;
					gesamtHelligkeitInt = (int) gesamtHelligkeit;
					brush.Color = Color.FromArgb(gesamtHelligkeitInt, gesamtHelligkeitInt, gesamtHelligkeitInt);
					g.FillRectangle(brush, x * myScale, y * myScale, myScale, myScale);
				}
			}
			
			int se = DateTime.Now.Second - dt.Second;
			//MessageBox.Show(se.ToString() + "s");
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 573);
			this.Name = "frmMain";
			this.Text = "Sternenhimmel";

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}
	}
}